{
gZoom
http://zarko-gajic.iz.hr/gzoom-delphi-implementation-of-the-missing-mode-in-windows-magnifier/
Zoom in portion of your desktop screen like a loupe.

arko Gaji
********************************************
}

unit uZoom;

interface

uses
  ShellApi,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, Buttons;

type
  TMainForm = class(TForm)
    zoomImage: TImage;
    zoomTimer: TTimer;
    pnlMain: TPanel;
    gbZoomFactor: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    tbZoomFactor: TTrackBar;
    chkCrosshair: TCheckBox;
    lblLink: TLabel;
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure zoomTimerTimer(Sender: TObject);
    procedure lblLinkMouseEnter(Sender: TObject);
    procedure lblLinkMouseLeave(Sender: TObject);
    procedure lblLinkClick(Sender: TObject);
  private
     procedure WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo); message WM_GETMINMAXINFO;
  public
  end;

var
  MainForm: TMainForm;

implementation
{$R *.DFM}

procedure TMainForm.WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo);
begin
   inherited;
   Msg.MinMaxInfo^.ptMinTrackSize := Point(158, 177); // min form size
   Msg.MinMaxInfo^.ptMaxTrackSize := Point(350, 350); // max form size (width, height)
end;


procedure TMainForm.FormResize(Sender: TObject);
begin
	// panel in the middle of the form
  pnlMain.Left:=(MainForm.ClientWidth div 2) - pnlMain.Width div 2;
  pnlMain.Top:=(MainForm.ClientHeight div 2) - pnlMain.Height div 2;

  zoomImage.Picture:=nil;
end;

procedure TMainForm.lblLinkClick(Sender: TObject);
begin
  ShellExecute(Handle,'open',PChar(lblLink.Caption),'','',SW_SHOW);
end;

procedure TMainForm.lblLinkMouseEnter(Sender: TObject);
begin
  lblLink.Font.Style := [fsUnderline];
end;

procedure TMainForm.lblLinkMouseLeave(Sender: TObject);
begin
  lblLink.Font.Style := [];
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
	zoomTimer.Interval := 0;
end;

procedure TMainForm.zoomTimerTimer(Sender: TObject);
var
  srcRect,destRect,fmrRect:TRect;
  iWidth,iHeight,DmX,DmY:Integer;
  iTmpX,iTmpY:Real;
  C:TCanvas;
  hDesktop: Hwnd;
  curPos:TPoint;
begin
  if not IsIconic(Application.Handle) then
  begin
    hDesktop := GetDesktopWindow;
    GetCursorPos(curPos);
    fmrRect:=Rect(MainForm.Left,MainForm.Top,MainForm.Left+MainForm.Width,MainForm.Top+MainForm.Height);

    if not PtInRect(fmrRect,curPos) then
    begin
      if pnlMain.Visible then pnlMain.Visible := False;
      if NOT zoomImage.Visible then zoomImage.Visible := True;

      iWidth:=zoomImage.Width;
      iHeight:=zoomImage.Height;
      destRect:=Rect(0,0,iWidth,iHeight);

      iTmpX:=iWidth / (tbZoomFactor.Position * 4);
      iTmpY:=iHeight / (tbZoomFactor.Position * 4);

      srcRect:=Rect(curPos.x,curPos.y,curPos.x,curPos.y);
      InflateRect(srcRect,Round(iTmpX),Round(iTmpY));

      If srcRect.Left<0 then OffsetRect(srcRect,-srcRect.Left,0);
      If srcRect.Top<0 then OffsetRect(srcRect,0,-srcRect.Top);
      If srcRect.Right>Screen.DesktopWidth then OffsetRect(srcRect,-(srcRect.Right-Screen.DesktopWidth),0);
      If srcRect.Bottom>Screen.DesktopHeight then OffsetRect(srcRect,0,-(srcRect.Bottom-Screen.DesktopHeight));

      C := TCanvas.Create;
      try
        C.Handle := GetDC(GetDesktopWindow);

        zoomImage.Canvas.CopyRect(destRect,C,srcRect);
      finally
        ReleaseDC(hDesktop, C.Handle);
        C.Free;
      end;

      If chkCrosshair.Checked then
      begin // show crosshair
        with zoomImage.Canvas do
        begin
          DmX:=tbZoomFactor.Position * 2 * (curPos.X-srcRect.Left);
          DmY:=tbZoomFactor.Position * 2 * (curPos.Y-srcRect.Top);
          MoveTo(DmX - (iWidth div 4),DmY); // -
          LineTo(DmX + (iWidth div 4),DmY); // -
          MoveTo(DmX,DmY - (iHeight div 4)); // |
          LineTo(DmX,DmY + (iHeight div 4)); // |
        end; // with image1.Canvas
      end; // show crosshair
    end // Cursor not inside form
    else
    begin  // cursor inside form
      if NOT pnlMain.Visible then pnlMain.Visible := True;
      if zoomImage.Visible then zoomImage.Visible := False;
    end;
  end; // IsIconic
end;

end.
